<?php

/**
 * inf_reparto actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_reparto
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_repartoActions extends sfQuery {
    /*
     * ------VARIABLES PARA SERVICIOS DE CONSULTA - LIST ---------------
     */

    protected $table_names = array(
        'CBR_REPARTO',
        'CBR_REMISION_TITULO',
        'CBR_ABOGADO_V',
        'INTERCEROS_V',
        'CBR_PAR',
        'CBR_ABOGADO_ULT_V',
        'CBR_REMISION_TIT_AGRUP_V',
        'CBR_REMISION_TITULO_DET_V',
        'CBR_ESTADO_PROCESO'
    ); //Tablas necesarias para construir la cosnulta sql.
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REPARTO'
        ),
        'CBR_ABOGADO_V,LEFT' =>
        array(
            'id_abogado' => 'CBR_REPARTO'
        ),
        'INTERCEROS_V,LEFT' =>
        array(
            'usuario_log-id_mae_ter' => 'CBR_REMISION_TITULO'
        ),
        'CBR_PAR,LEFT' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REPARTO'
        ),
        'CBR_REMISION_TIT_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_TITULO_DET_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ESTADO_PROCESO,LEFT' =>
        array(
            'id_estado_proceso' => 'CBR_REPARTO'
        )
    ); //Identificadores de los campos que se usaran para declarar los joins.
    protected $fields = array(
        'CBR_REPARTO' =>
        array(
            'id_reparto' => 'id_reparto',
            'id_remision_titulo' => 'id_remision_titulo',
            //'id_abogado' => 'id_abogado',
            'fecha_reparto' => 'fecha_reparto',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'estado' => 'estado_rep'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'radicado',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_ABOGADO_V' =>
        array(
            'id_mae_ter' => 'id_mae_ter',
            'email' => 'email',
            'id_abogado' => 'id_abogado',
            'num_doc' => 'num_doc',
            'razon_soc' => 'abogado'
        ),
        'INTERCEROS_V' =>
        array(
            'num_doc' => 'num_docc',
            'razon_soc' => 'usuario',
        ),
        'CBR_PAR' =>
        array(
            'codigo' => 'codigo',
            'descripcion' => 'descripcion'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => 'id_abogado_ult',
            'num_doc' => 'num_doc_ult',
            'razon_soc' => 'abogado_ult'
        ),
        'CBR_REMISION_TIT_AGRUP_V' =>
        array(
            'cod_titulo_det_agrup' => 'cod_titulo_det_agrup',
            'observaciones_det_agrup' => 'observaciones_det_agrup',
            'mineral_det_agrup' => 'mineral_det_agrup'
        ),
        'CBR_ESTADO_PROCESO' =>
        array(
            'descripcion' => 'estado_proceso'
        )
    ); //Campos que retornará la consulta
    protected $fields_orderBy = array(
        'num_doc', 'fecha_reparto', 'anho_remision', 'numero_remision', 'radicado'
    ); //Criterio para ordenar los registros arrojados por la consulta

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REPARTO' =>
        array(
            'id_reparto,a' => array('!=' => array(-1)),
            'id_reparto,b' => array('=' => array('id_reparto')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'fecha_reparto' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            // 'id_abogado' => array('=' => array('id_abogado')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'estado' => array('=' => array('id_estado')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'id_par' => array('=' => array('id_par'))
        ),
        'CBR_ABOGADO_V' =>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('=' => array('num_doc'))
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); // Condiciones para filtrar registros arrojados por la consulta
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or    
    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //si es servicio para filtro agregar campo
    protected $filtro = 'Informe REparto';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = false;

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateRemove(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    /**
     * Executes index action
     * 
     * Se deja de usar la función executeList de arriba y se extiende esta clase del manejador de consultas sfQuery
     *
     * @param sfRequest $request A request object     
     */
    public function executeList2(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_debito_ref');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */

            $where = "";
            $whereTituloMinero = "";
            $whereAbogado = "";
            $wherePar = "";

            if (isset($request['id_par'])) {
                $wherePar = " AND tab0.id_par=" . $request['id_par'];
            }

            if (isset($request['cod_titulo'])) {
                $whereTituloMinero .= " AND tab0.cod_titulo='" . $request['cod_titulo'] . "'";
            }

            if (isset($request['id_abogado'])) {
                $whereAbogado .= " AND tab0.id_abogado =" . $request['id_abogado'];
            }

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
select tab0.*

from(
select tab4.razon_soc AS ABOGADO, to_char(tab0.fecha_reparto,'DD/MM/YYYY') fecha_reparto,tab3.cod_titulo TITULO,tab1.numero_correpondencia RADICADO,tab5.descripcion AS PAR,
tab0.id_abogado,tab1.cod_titulo,tab1.id_par

from cbr_reparto tab0
left join cbr_remision_titulo tab1 ON tab1.id_remision_titulo = tab0.id_remision_titulo
left join cbr_abogado tab2 ON tab2.id_abogado = tab0.id_abogado
left join CBR_REPARTO tab3 ON tab3.cod_titulo = tab1.tab1.cod_titulo
left join interceros_v tab4 ON tab4.id_mae_ter = tab2.id_mae_ter
left join cbr_par tab5 ON tab5.id_par = tab1.id_par
)tab0
where 1=1
$whereAbogado $wherePar $whereTituloMinero
ORDER BY tab0.abogado,tab0.titulo
                    
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
